import { Handle } from "./interfaces";

import { DeclareConstructor } from "./_base/declare";
import { ExtensionEvent } from "./on";

interface Evented {
    on(type: string | ExtensionEvent, listener: EventListener | Function): Handle;
    emit(type: string | ExtensionEvent, ...events: any[]): boolean;
}

interface EventedConstructor extends DeclareConstructor<Evented> {
    new (params?: Object): Evented;
}

declare const Evented: EventedConstructor;
export = Evented;
